include( "shared.lua" )

SWEP.DrawAmmo			= true					-- Should draw the default HL2 ammo counter
SWEP.DrawCrosshair		= true 					-- Should draw the default crosshair
SWEP.DrawWeaponInfoBox	= true					-- Should draw the weapon info box
SWEP.BounceWeaponIcon   = false					-- Should the weapon icon bounce?
SWEP.SwayScale			= 1.0					-- The scale of the viewmodel sway
SWEP.BobScale			= 1.0					-- The scale of the viewmodel bob

function SWEP:AdjustMouseSensitivity()
	if ( self:GetNetworkedBool( "Scoped" ) == true ) then
		return 0.075
	elseif ( self:GetNetworkedBool( "Scoped" ) == false ) then
		return 1
	end
end

function SWEP:DrawHUD()
	if ( self:GetNetworkedBool( "Scoped" ) == false ) then return end
	--Look at all these temporary variables, getting written and read every frame...yuck!
	
	local screenheight = surface.ScreenHeight() -- 900
	local screenwidth = surface.ScreenWidth() -- 1440
	local scopewidth = ( 4 / 3 ) * screenheight -- 1200
	local marginwidth = ( ( screenwidth - scopewidth ) / 2 ) -- 120
	
	--Scrap space:
	
	surface.SetDrawColor( 0, 0, 0, 255 )
	surface.DrawRect( 0, 0, marginwidth, screenheight )
	surface.DrawRect( (screenwidth - marginwidth), 0, marginwidth, screenheight )
	
	local ul = surface.GetTextureID( "sprites/scopes/scope_spring_ul" )
	local ur = surface.GetTextureID( "sprites/scopes/scope_spring_ur" )
	local ll = surface.GetTextureID( "sprites/scopes/scope_spring_ll" )
	local lr = surface.GetTextureID( "sprites/scopes/scope_spring_lr" )
	
	--Scope lens pieces:
	
	surface.SetTexture( ul )
	surface.DrawTexturedRect( marginwidth, 0, ( 0.5 * scopewidth ), ( 0.5 * screenheight ) )
	surface.SetTexture( ur )
	surface.DrawTexturedRect( ( 0.5 * screenwidth), 0, ( 0.5 * scopewidth ), ( 0.5 * screenheight ) )
	surface.SetTexture( ll )
	surface.DrawTexturedRect( marginwidth, ( 0.5 * screenheight ), ( 0.5 * scopewidth ), ( 0.5 * screenheight ) )
	surface.SetTexture( lr )
	surface.DrawTexturedRect( ( 0.5 * screenwidth), ( 0.5 * screenheight ), ( 0.5 * scopewidth ), ( 0.5 * screenheight ) )
	
	--Scope crosshair:
	
	surface.DrawLine( ( 0.5 * screenwidth), 0, ( 0.5 * screenwidth ), screenheight ) -- Vertical bar
	surface.DrawLine( 0, ( 0.5 * screenheight), screenwidth, ( 0.5 * screenheight ) ) -- Horizontal bar
end