AddCSLuaFile( "shared.lua" )
SWEP.Base = "weapon_base"
SWEP.Spawnable = true
SWEP.Category = "Other"

SWEP.Author	=	"Technician Fry"
SWEP.Purpose			= "Take down large game"
SWEP.Instructions			= "Secondary attack toggles scope"

SWEP.ViewModel = "models/weapons/v_bar_safari.mdl"
SWEP.WorldModel = "models/weapons/w_bar_safari.mdl"

SWEP.ReloadSequence	=	3
SWEP.DrawSequence	=	1
SWEP.IdleEmptyAnim	=	nil
SWEP.FireLastAnim	=	nil

SWEP.ViewModelFOV	= 63
SWEP.ViewModelFlip	= false

SWEP.Primary.Damage = 70
SWEP.Primary.Force = 2
SWEP.Primary.BulletType = "Pistol"
SWEP.Primary.Aimcone = 0.0005 --Change this while scoped?
SWEP.VerticalRecoil = 4.75
SWEP.HorizontalRecoil = 1.50

SWEP.PrintName			= "Elephant Rifle"		-- 'Nice' Weapon name (Shown on HUD)	
SWEP.Slot				= 3						-- Slot in the weapon selection menu
SWEP.SlotPos			= 0					-- Position in the slot

SWEP.CanChamberExtraRound	=	false -- For simplicity's sake

SWEP.MagazineCapacity	= 10
SWEP.Primary.ClipSize		= SWEP.MagazineCapacity	-- Initial capacity of a magazine
SWEP.Primary.DefaultClip	= 40				-- Default number of bullets in a clip

SWEP.CanFireUnderwater	=	true
SWEP.Primary.Automatic		= false				-- Automatic/Semi Auto
SWEP.Primary.Ammo			= "357"

SWEP.FiringSound = Sound( "weapons/bar_safari.wav" )
SWEP.EmptySound = Sound( "Default.ClipEmpty_Rifle" )
SWEP.ZoomSound = Sound( "Default.Zoom" )
SWEP.ExtraReloadSound = nil

SWEP.Secondary.ClipSize		= -1					-- Size of a clip
SWEP.Secondary.DefaultClip	= -1			-- Default number of bullets in a clip
SWEP.Secondary.Automatic	= false				-- Automatic/Semi Auto
SWEP.Secondary.Ammo			= "none"

SWEP.NextPrimaryAttack = CurTime()
SWEP.NextSecondaryAttack = CurTime()
SWEP.NextReload = CurTime()
SWEP.InitialOwnerFOV = 0
 
SWEP.AnimationLength =
{
	["draw"]	=	( 46 / 33 ),
	["fire"]	=	( 41 / 50 ),
	["firelast"]	=	nil,
	["reload"]	=	( 129 / 43 )
}

SWEP.HoldType = "ar2"

function SWEP:Initialize()
	self:SetWeaponHoldType( self.HoldType )
	self.IsReloading = false
	self.ShouldBeAutomatic = false
	
	self:SetNetworkedBool( "Scoped", false )
	if ( SERVER ) and ( self.Owner ) and ( self.Owner.GetFOV ) then self.InitialOwnerFOV = self.Owner:GetFOV() end
	self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
	self.NextPrimaryAttack = CurTime() + self.AnimationLength.draw
	self.NextSecondaryAttack = CurTime() + self.AnimationLength.draw
	self.NextReload = CurTime() + self.AnimationLength.draw
end

function SWEP:Deploy()
	if ( self.Owner:GetFOV() ) then self.InitialOwnerFOV = self.Owner:GetFOV() end
	self:SetWeaponHoldType( self.HoldType )
	self.IsReloading = false
	
	self:SetNetworkedBool( "Scoped", false )
	self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
	self.NextPrimaryAttack = CurTime() + self.AnimationLength.draw
	self.NextSecondaryAttack = CurTime() + self.AnimationLength.draw
	self.NextReload = CurTime() + self.AnimationLength.draw
	return true
end

function SWEP:Holster()
	
	self:SetNetworkedBool( "Scoped", false )
	self.Owner:SetFOV( self.InitialOwnerFOV, 0.3 )
	
	self.NextPrimaryAttack = CurTime()
	self.NextSecondaryAttack = CurTime()
	self.NextReload = CurTime()
	return true
end

function SWEP:CanPrimaryAttack()
	if ( self.Weapon:Clip1() <= 0 ) then
		return false
	else
		return true
	end
end

function SWEP:PrimaryAttack()
	if ( self.NextPrimaryAttack > CurTime() ) then return end
	
	if ( !self:CanPrimaryAttack() ) then --Out of ammo?
		self.Primary.Automatic	=	false
		
		--USE A DIFFERENT AUDIO CHANNEL FOR THIS!
		--otherwise, you'll stop the firing sound awkwardly
		--self:EmitSound( self.EmptySound )
		if ( SinglePlayer() ) or ( CLIENT ) then WorldSound( self.EmptySound, self.Owner:GetPos() ) end
		
		return
	end

	self.Primary.Automatic = self.ShouldBeAutomatic
	
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
		
	--In multiplayer: both server and client true, but not singleplayer
	--In singleplayer: both server and singleplayer true, but not client
	
	--if ( SinglePlayer() ) or ( CLIENT ) or ( self.Owner:IsNPC() ) then
	self.Weapon:EmitSound( self.FiringSound )
	--end	
	

	
	self.Owner:SetAnimation( PLAYER_ATTACK1 )
	self:TakePrimaryAmmo( 1 )

	local bullet = {}
	bullet.Num 		= 1
	bullet.Src 		= self.Owner:GetShootPos()			-- Source
	bullet.Dir 		= self.Owner:GetAimVector()			-- Dir of bullet
	bullet.Spread 	= Vector( self.Primary.Aimcone, self.Primary.Aimcone, 0 )		-- Aim Cone
	bullet.Tracer	= 1									-- Show a tracer on every x bullets 
	bullet.Force	= self.Primary.Force				-- Amount of force to give to phys objects
	bullet.Damage	= self.Primary.Damage
	bullet.AmmoType = self.Primary.BulletType
	
	self.Owner:FireBullets( bullet )
	
	local vert = self.VerticalRecoil -- ( 6 )
	local hormin, hormax = ( -1 * self.HorizontalRecoil ), self.HorizontalRecoil -- ( -3 )
	
	if ( self.Owner:IsPlayer() ) then
		self.Owner:SetEyeAngles( self.Owner:EyeAngles() - Vector( vert, math.Rand( hormin, hormax ), 0 ) )
		if ( self.ShouldBeAutomatic == false ) then self.Owner:ViewPunch( Vector( ( 0.5 * ( -1 * vert ) ), 0, 0 ) ) end
	end
	
	self.NextPrimaryAttack = CurTime() + ( self.AnimationLength.fire * ( 1 / 2 ) )
	
end

function SWEP:SecondaryAttack()
	if ( self.NextSecondaryAttack > CurTime() ) then return end
		
	if ( self:GetNetworkedBool( "Scoped" ) == false ) then
		self:ZoomIn()
	elseif ( self:GetNetworkedBool( "Scoped" ) == true ) then
		self:ZoomOut()
	end
	
	self.NextPrimaryAttack = CurTime() + 0.35
	self.NextSecondaryAttack = CurTime() + 0.35
	self.NextReload = CurTime() + 0.35
end

function SWEP:ZoomIn()
	self:SetNetworkedBool( "Scoped", true )
	
	self.Owner:SetFOV( ( self.InitialOwnerFOV - 60 ), 0.3 )
	if ( SinglePlayer() ) or ( CLIENT ) then self.Weapon:EmitSound( self.ZoomSound ) end
	if ( SERVER ) then self.Owner:DrawViewModel( false ) end
	if ( SERVER ) then self.Owner:CrosshairDisable() end
end

function SWEP:ZoomOut()
	self:SetNetworkedBool( "Scoped", false )

	self.Owner:SetFOV( ( self.InitialOwnerFOV ), 0.3 )
	if ( SinglePlayer() ) or ( CLIENT ) then self.Weapon:EmitSound( self.ZoomSound ) end
	if ( SERVER ) then self.Owner:DrawViewModel( true ) end
	if ( SERVER ) then self.Owner:CrosshairEnable() end
end

function SWEP:Reload()

	if ( self.NextReload > CurTime() ) then return end
	if ( ( self.CanChamberExtraRound == true ) and ( self.Weapon:Clip1() == ( self.MagazineCapacity + 1 ) ) ) then return end
	if ( ( self.CanChamberExtraRound == false ) and ( self.Weapon:Clip1() == self.MagazineCapacity ) ) then return end
	
	if ( self:Ammo1() <= 0 ) then return end
	
	if ( self:GetNetworkedBool( "Scoped" ) == true ) then self:ZoomOut() end
	
	if ( self.CanChamberExtraRound == true ) and ( self.Weapon:Clip1() > 0 ) then
		self.Primary.ClipSize = self.MagazineCapacity + 1
	else
		self.Primary.ClipSize = self.MagazineCapacity
	end
	
	self.IsReloading = self.Weapon:DefaultReload( ACT_VM_RELOAD ) --Sets current ammo to ClipSize, subtracts the ammo difference from reserve ammo

end